GJDOC(1)

NAME
cp-tools - GNU Classpath Tools Guide

SYNOPSIS
gjdoc [-sourcepath pathlist]
      [-all] [-subpackages pkg:pkg:...] [-exclude pkglist]
      [-encoding charset] [-locale name] [-source release]
      [-public] [-protected] [-package] [-private]
      [-doctitle text] [-header text] [-footer text] [-bottom text]
      [-link url] [-linkoffline url path] [-noqualifier pkg:pkg:...]
      [-tagletpath pathlist] [-taglet className] [-tag tagspec]
      [-use] [-linksource] [-splitindex] [-noindex] [-notree]
      [-version] [-author] [-nosince] [-addstylesheet file]
      [-d targetdir]
      [packages...] [sourcefiles...] [@cmdfile]

gjdoc [-sourcepath pathlist]
      [-all] [-subpackages pkg:pkg:...] [-exclude pkglist]
      [-encoding charset] [-locale name] [-source release]
      [-public] [-protected] [-package] [-private]
      [-docletpath pathlist] [-doclet className]
      [packages...] [sourcefiles...] [@cmdfile]
      [doclet options]

gjdoc --help

gjdoc --version

Only the most useful options are listed here; see below for the remainder.

DESCRIPTION
Gjdoc can be used in two ways: as a stand-alone documentation tool, or as a driver for a user-specified Doclet.

In the default mode, Gjdoc will use the Standard Doclet HtmlDoclet to generate a set of HTML pages. The canonical usage is:

        gjdoc -s src/java/ -all -d api-docs/

Here, src/java/ is the root of your source code class hierarchy, -all means that all valid Java files found under this root directory should be processed, and api-docs/ is the directory where the generated documentation should be placed.

To learn more about running Doclets other than the Standard Doclet, refer to the manual.

OPTIONS

  Option Summary by Type
Here is a summary of all the options of both Gjdoc and the Standard Doclet, grouped by type. Explanations are in the following sections.

Source Set Options
    -sourcepath pathlist -subpackages pkglist -exclude pkglist

Source Format Options
    -source release -encoding encoding -breakiterator

Interlinking Options
    -link url -linkoffline url file -noqualifier pkg:pkg:...

Generation Options
    -author -licensetext -use -version -splitindex -noindex
     -nodeprecated -nodeprecatedlist -nohelp -nonavbar
     -nosince -notree -public -protected -package -private
     -docfilessubdirs -excludedocfilessubdir dirname
     -linksource

Output Options
    -d -locale name -charset charset -docencoding charset
     -validhtml -baseurl url

Decoration Options
    -windowtitle text -doctitle text -title text
     -header text -footer text -bottom text
     -helpfile file -stylesheetfile file -addstylesheet file
     -group groupheading pkgpattern:pkgpattern:...

Taglet Options
    -tagletpath -taglet classname -tag tagspec

Doclet Options
    -docletpath -doclet classname

Verbosity Options
    -quiet -verbose

Virtual Machine Options
    -classpath -bootclasspath -J vmopt

  Selecting which Source Files to Process

-s pathlist
-sourcepath pathlist
    Look for source files in the specified directory or directories.

    pathlist should be one or more directory paths separated by your platform's path separator (usually : or ;).

    If this option is not given, gjdoc will look for source files in the current directory.

    The directories specified should be root directories in terms of the Java package system. For example, if you want to generate documentation for classes in package foo.bar, you must specify the directory containing the top-level foo sub-directory, not the directory foo/bar/ in which the Java source files reside.

    The short-hand alias -s is specific to gjdoc and not compatible to Sun javadoc.

-all
    [EXPERIMENTAL] Process all valid Java source files found in the directories listed in the source path and their sub-directories.

    This is an option specific to gjdoc and not compatible to Sun javadoc.

-subpackages pkg:pkg:...
    Process the classes in the given Java packages and all sub-packages, recursively. Note that multiple package names must be separated with colons instead of whitespace.

-exclude pkg:pkg:...
    Do not process classes in the given Java packages and all sub-packages, recursively. This option can be used in conjunction with -all or -subpackages in order to exclude individual packages or package sub-trees from the output.

packages...
    Process all classes in the given Java packages.

sourcefiles...
    Process the classes in the given Java source files.

  Specifying the Format of Input Files

-source release
    Assume that the source files are targeted at the given release of the Java platform.

    release should be the version number of a Java platform release in the format MAJOR.MINOR, for example 1.4.

    This option is currently ignored except that an error is raised if a release number other than 1.2, 1.3 or 1.4 is specified.

-encoding charset
    Assume that the source files are encoded using charset.

    Examples for charset are US-ASCII, ISO-8859-1 or UTF-8.

    The semantics of charset are identical to those of java.nio.charset.Charset.forName(String).

-breakiterator
    Use the locale's java.text.BreakIterator instead of the internal first sentence detector.

    By default, gjdoc uses an internal algorithm to determine where a sentence ends. When this option is given, it will instead use the java.text.BreakIterator instance for the locale given with -locale (or the default locale).

    This option should be specified when applying gjdoc to source code commented in a non-latin language for which the default first sentence detector does not work. For all other cases, the default (do not use BreakIterator) produces better results at the time of this writing.

  Interlinking with other Documentation Sets

-link url
    Create hyperlinks to another documentation set.

    By default, gjdoc will only create hyperlinks to classes in the source set. Use this option to additionally create hyperlinks to classes covered by the specified documentation set.

    url should be the root URL of the other documentation set. For example, to add hyperlinks to GNU Classpath, specify the following:

            -link http://developer.classpath.org/doc/

    The -link option can be specified multiple times.

    Note that specifying the -link option will cause an HTTP access every time gjdoc is invoked. You can use -linkoffline instead to avoid this access.

-linkoffline url file
    Create hyperlinks to another documentation set which is also present on the local file system.

    This option works exactly like -link, except that it accesses the local file system instead of the network for determining which classes are covered by the linked documentation set.

    When using -linkoffline the remote documentation set is not accessed at all, which can significantly speed up generation time depending on your network connection. The generated hyperlinks to the documentation set however refer to the remote set, not to the local one, so that you can distribute the documentation without any further dependencies.

    The -linkoffline option can be specified multiple times.

-noqualifier pkg:pkg:...
    Do not qualify names of classes in the given packages with their package name.

    By default, a class name is displayed unqualified only if the class is part of the source set or a linked documentation set, and qualified with the name of its containing package if it is not. You can use this option to force unqualified names for classes even if they are not part of the documentation set.

    For example, usually a reference to the String class is represented fully-qualified as java.lang.String (unless you link to the appropriate documentation set using -link) because it isn't part of the documentation set. You can specify -noqualifier java.lang to render the same references just as String.

    Note that for all unqualified class names, a tooltip is provided when you place your mouse pointer over it in the HTML documentation.

-noqualifier all
    Omit package name qualifier from all class names.

    Specify this option to omit package name qualifiers altogether,

  Selecting which Information to Generate

-public
    Only include public members of public classes in the output. By default, protected class members are included as well.

-protected
    Include public or protected members of public classes in the output. This is the default.

-package
    Include public, protected and package-private members of public and package-private classes.

-private
    Include all classes and class members regardless of their access level.

-splitindex
    Generate one index page per letter instead of a single, monolithic index page.

    By default, the index created by the Standard Doclet contains all entries on a single page. This is fine for small documentation sets, but for large sets you should specify this option.

-nosince
    Ignore @since tags in javadoc comments.

    By default, the generated output contains sections listing the version of your API since which the package, class or class member in question exists when this tag is encountered. Specify this option to omit this information.

-notree
    Do not generate any tree pages.

    By default, the generated output includes one inheritance tree per package, and - if the documentation set consists of multiple packages - a page with the full inheritance tree. Specify this option to omit generation of these pages.

-noindex
    Do not output the alphabetical index.

    By default, gjdoc generates an alphabetical index of all program elements in the documentation set (packages, classes, inner classes, constructors, methods, and fields). Specify this option to omit this information.

-nohelp
    Do not generate the help page.

    This option is currently ignored as the Standard Doclet doesn't provide a help page.

-nodeprecated
    Do not output inline information about deprecated packages, classes or class members.

    By default, the Standard Doclet adds a highlighted paragraph with deprecation information to the description of each deprecated program element. Specify this option to omit this information.

-nodeprecatedlist
    Do not output the summary page for deprecated API elements.

    By default, the Standard Doclet generates a page listing all deprecated API elements along with a deprecation description which usually includes the reason for deprecation and possible alternatives. Specify this option to omit this information.

-nonavbar
    Do not output the navigation bar, header, and footer.

    By default, each output page is equipped with a top navigation bar (which may include a user-specified header) and a bottom navigation bar (which may include a user-specified footer). Specify this option to omit this decoration.

-nocomment
    Omit all documentation text from the generated files and output only declarations and program element relationships.

    This option is here for compatibility with javadoc. If you plan on extracting information about your project via gjdoc, you should consider using a different Doclet for your purposes instead, for example XmlDoclet. You could also use the Doclet API directly by implementing a new Doclet.

-linksource
    Generate a page with syntax-highlighted source code for each class. By default, this page is not generated.

    The source code can be accessed by clicking on the button labelled "Source" in the navigation bar, or by clicking on the name of a constructor, field, method, or inner class in the detail section of a class documentation page.

-use
    Generate a page with cross-reference information. By default, this page is not generated.

    The cross-reference information can be accessed by clicking on the button labelled `Use' in the navigation bar.

    The `Use' page lists all classes/interfaces in the documentation set that extend/implement the class (type) in question; fields of the type; methods or constructors accepting a parameter of the type; methods returning the type; and methods or constructors throwing the type.

-author
    Include author information in the output.

    When specified, author information as specified using the @author tag in javadoc comments is incorporated into the output. By default, @author tags are ignored.

-version
    Include version information in the output.

    When specified, version information as specified using the @version tag in javadoc comments is incorporated into the output. By default, @version tags are ignored.

-licensetext
    Assume that the first comment in each source file contains the license text, and add license information to the footer of each generated class page.

    This is an option specific to gjdoc and not compatible to Sun javadoc.

    This option is intended for use with free and open source projects where source code is typically prefixed with a boilerplate license comment, when there are legal reasons for including the license in the documentation.

-docfilessubdirs
    Recursively copy all files in the doc-files sub-directory of each package directory.

    Usually, only the files in the doc-files sub-directory are copied without descending recursively.

-excludedocfilessubdir name:name:...
    Do not copy some directories directly under the doc-files sub-directories when descending recursively.

    The argument to this option should be a colon-separated list of directory names.

    This option only makes sense if -docfilessubdirs is also specified. In this case, any sub-directory located directly beneath a doc-files directory is omitted if listed.

  Custom Documentation Tags

-tagletpath pathlist
    Search pathlist when loading subsequent Taglet classes specified using -taglet.

    pathlist should be one or more paths to a directory or jar file, separated by your platform's path separator (usually : or ;).

-taglet classname
    Register a Taglet.

    classname should be the fully-qualified name of a Java class implementing com.sun.tools.doclets.Taglet.

    The Taglet classes will be loaded from the classpath specified using -tagletpath, from the classpath specified using -classpath and from the default classpath.

    See the documentation of com.sun.tools.doclets.Taglet for further information.

    Note that for simple tags, there is also -tag.

-tag tagspec
    Register a generic Taglet.

    The format of tagspec must be <tagname>:<flags>:"<taghead>".

    tagname is the tag name to match, without the leading @ sign.

    flags is one or more of the following characters, where each character specifies a source code context in which the tag is to be recognized.

    a   all contexts

    c   constructors

    f   fields

    m   methods

    o   overview

    p   packages

    t   types (classes, interfaces, exceptions, errors)

    X   special character which temporarily disables the Taglet altogether.

    taghead is the string to display in the header of the section devoted to the tag in question.

    For example, to define a tag matching @cvsid which is to be accepted in overview, package and type pages and which is labelled with the header CVS ID, you would specify:

            -tag cvsid:tpo:"CVS ID"

    Let's say that a class javadoc comment contains

            @cvsid $Id: cp-tools.texinfo,v 1.9 2012-03-07 15:27:27 gnu_andrew Exp $

    Then the HTML output will contain something like

            CVS ID:
              $Id: cp-tools.texinfo,v 1.9 2012-03-07 15:27:27 gnu_andrew Exp $

  Running Other Doclets

-docletpath pathlist
    Search pathlist when loading classes for the Doclet specified using -doclet.

    pathlist should be one or more paths to a directory or jar file, separated by your platform's path separator (usually : or ;).

-doclet className
    Run the specified doclet instead of the standard HtmlDoclet.

    className should be the fully-qualified name of a class which has a public default constructor and contain a method with the following signature:

               import com.sun.javadoc.RootDoc;
               public static boolean start(RootDoc rootDoc)

    The Doclet classes will be loaded from the classpath specified using -docletpath, from the classpath specified using -classpath and from the default classpath.

    The start method should process the information exposed by the Doclet API via rootDoc and return true on success, false on failure.

    If you are using a third-party doclet, refer to its documentation for further instructions. Note that support for third-party doclets is experimental. Please report any problems you encounter, or provide feedback when successfully running third-party applets.

    This option can be specified multiple times, in which case all doclets are executed with the same information tree exposed via the Doclet API for each Doclet run.

  Adding Information to the Output

-windowtitle text
    Use text as the browser window title prefix.

    When specified, the browser window title for each page will be prefixed with text instead of the default string Generated API Documentation.

    text should be plain text (it should not contain HTML tags).

-doctitle text
    Set the header text of the overview page to text.

    text should be a short plain text string.

    When generating documentation for a single package, specifying this option forces generation of the overview page.

-header htmltext
    Add htmltext to the right upper corner of every generated page. htmltext is usually set to the name of the project being documented.

-footer htmltext
    Add htmltext to the right bottom corner of every generated page. htmltext is often set to the same value as for -header.

-bottom htmltext
    Add htmltext to the very bottom of every generated page, spanning the whole width of the page. When specified, htmltext usually consists of a copyright notice and/or links to other project pages.

-addstylesheet file
    Augment the default CSS style sheets with the user-specified stylesheet file.

    The given stylesheet is simply loaded by each HTML page in addition to the default ones, as the last stylesheet.

    Note that the CSS cascading rules apply. That is, your style properties will only be assigned if they have a higher cascading order than gjdoc's default style. One simple way to make sure that this is the case is to declare your overrides !important.

    See <http://www.w3.org/TR/REC-CSS2/cascade.html#cascading-order>.

-group heading pkgwildcard:pkgwildcard:...
    Arrange the given packages in a separate group on the overview page.

    The first argument should be a short plain text which is used as the title of the package group. The second argument should be a colon-separated list of package wildcards. The group will consist of all packages in the documentation set whose name matches any of the given wildcards.

    There is only one wildcard character, *, which matches both letters in package name components and the . separating package name components. For example, j*regex would match package java.util.regex. A more useful example would be javax.swing* to match javax.swing and all of its sub-packages.

    This option can be given multiple times.

    FIXME: Information about group nesting here.

            gjdoc -group "Core Classes" 'java*' \
                  -group "Swing" 'javax.swing*' \
                  -group "XML APIs" 'javax.xml*' \
                  -group "Other Extensions" javax* \
                  ...

-overview file
    Add the XHTML body fragment from file to the overview page.

    file should contain an XHTML fragment with the HTML body tag as the root node.

    This option can be used to supply a description of the documentation set as a whole.

    When specified, the first sentence of the fragment will be put above the tables listing the documented packages, along with a link to the full copy of the fragment which is put below the tables.

    When generating documentation for a single package, specifying this option forces generation of the overview page.

-stylesheetfile file
    Use the CSS stylesheet in file instead of the default CSS stylesheets.

    If you only want to override parts of the default stylesheets, use -addstylesheet instead.

-title text
    Deprecated. Use -doctitle text instead.

-helpfile file
    This option is currently ignored.

    When implemented, it will use the XHTML fragment in file for the help page contents instead of the default help text.

  Controlling the Output.

-d directory
    Place all output files into directory (and sub-directories). directory will be created if it does not exist, including all non-existing parent directories and all required sub-directories.

    If not specified, output will be placed into the current directory.

-locale name
    Use locale name instead of the default locale for all purposes.

    name should be a locale specifier in the form ll_CC[_VAR] where ll is a lowercase two-letter ISO-639 language code, CC is an optional uppercase two-letter ISO-3166 country code, and VAR is an optional variant code. For example, en specifies English, en_US specifies US English, and en_US_WIN specifies a deviant variant of the US English locale.

    Note that the semantics of this option correspond exactly to those of the constructors of class java.util.Locale.

    This option currently only determines which Collator is being used for sorting output elements. This means that the locale will only have an effect when you are using non-ASCII characters in identifiers.

-charset charset
    Deprecated. Override the specified encoding in output XHTML files with the one given by charset.

    If this option is not given, the encoding specification in output XHTML is chosen to match the encoding used when writing the file (the encoding given with -docencoding, or your platform's default encoding).

    The semantics for charset are specified here: <http://www.w3.org/TR/2000/REC-xml-20001006#NT-EncName>. For all practical purposes, they are identical to those of the other options accepting charset parameters.

    This option is here for compatibility with javadoc and should be avoided.

-docencoding charset
    Use the given charset encoding when writing output files instead of your platform's default encoding.

    Examples for charset are US-ASCII, ISO-8859-1 or UTF-8.

    The semantics of this option correspond exactly to those of the constructors of class java.util.Locale.

-validhtml
    Force generation of valid XHTML code. This breaks compatibility to the traditional Javadoc tool to some extent.

    If this option is specified, anchor names will be mangled so that they are valid according to the XHTML 1.1 specification. However, a documentation set generated with this option cannot be linked to properly using the traditional Javadoc tool. It can be linked to just fine using Gjdoc, though.

    Without this option, anchor names for executable class members use the traditional format, for example: "foo(String,int[])". This is compatible to the traditional Javadoc tool, but according to both the HTML 4.0 and XHTML 1.0 and 1.1 specifications, this format includes illegal characters. Parentheses, square brackets, and the comma are not allowed in anchor names.

-baseurl url
    Hardwire a page URL relative to url into each generated page.

    If you are generating documentation which will exclusively be available at a certain URL, you should use this option to specify this URL.

    This can help avoid certain redirect attacks used by spammers, and it can be helpful for certain web clients.

  Verbosity Options

-quiet
    Suppress all output except for warnings and error messages.

-verbose
    Be very verbose about what gjdoc is doing.

    This option is currently ignored.

  Virtual Machine Options
Sun's javadoc tool seems to be based on javac and as such it seems to operate on the VM level. gjdoc, in contrast, is a pure Java application.

Therefore, gjdoc can only fake, or simulate, the following VM-level options.

-classpath pathlist
    Set the Virtual Machine classpath to pathlist.

    In most cases you should use -docletpath or -tagletpath instead of this option.

    pathlist should be one or more paths to a directory or jar file, separated by your platform's path separator (usually : or ;).

    If this option is not intercepted at the wrapper level, gjdoc currently fakes it by calling System.setProperty("java.class.path", pathlist); and outputs a warning.

-bootclasspath pathlist
    Set the Virtual Machine bootclasspath to pathlist.

    If this option is not intercepted at the wrapper level, gjdoc outputs a warning.

-Jvmopt
    Pass an arbitrary parameter to the Virtual Machine gjdoc runs on.

    If this option is not intercepted at the wrapper level, gjdoc tries to emulate the option and outputs a warning.

    Currently, only the VM option -D for setting system properties is emulated.

BUGS
Please report bugs to <http://savannah.gnu.org/bugs/?group=classpath>.

SEE ALSO
Info entry for gjdoc.

AUTHOR
Julian Scheid